const _Http = getApp().globalData.http;
import currency from "../../utils/currency";
let CNY = value => currency(value, {
  symbol: "￥",
  precision: 2
}).format();
Page({
  data: {
    loading: true,
    params: {}, //请求体
    result: [], //返回结果
    radio: false, //是否为单选
    idname: "sa_accountclassid", //idkey
    showName: "accountname",
    subvalues: [],
    privacyFieldC: []
  },
  onLoad(options) {
    if (options.params) {
      let params = JSON.parse(options.params);
      if (!params.content.pageNumber || !params.content.pageTotal) {
        params.content.pageNumber = 1;
        params.content.pageTotal = 1;
      }
      this.setData({
        params
      });
    }

    try {
      let privacyFieldC = wx.getStorageSync('auth').waccount.forms.selectaccount.formcols.map(v => v.title);
      this.setData({
        privacyFieldC
      })
      console.log("privacyFieldC", privacyFieldC)
    } catch (error) {
      console.error(error)
    }

    this.setData({
      radio: options.radio ? true : false,
      idname: options.idname || this.data.idname,
      showName: options.showName || this.data.showName,
    });
    let that = this;

    if (options.tradefield) {
      let domainrelatedaccounts = wx.getStorageSync('domainrelatedaccounts');
      if (domainrelatedaccounts.length) {
        query()
      } else {
        _Http.basic({
          "classname": "sysmanage.develop.optiontype.optiontype",
          "method": "optiontypeselect",
          "content": {
            "pageNumber": 1,
            "pageSize": 9999,
            "typename": "domainrelatedaccounts"
          }
        }).then(res => {
          console.log("查询领域对应列表", res)
          if (res.msg == '成功' && res.data.length) {
            domainrelatedaccounts = res.data;
            wx.setStorageSync('domainrelatedaccounts', domainrelatedaccounts)
            query()
          }
        })
      }

      function query() {
        let item = domainrelatedaccounts.find(v => v.value == options.tradefield);
        that.setData({
          subvalues: item ? item.subvalues : []
        })
        that.getList()
      }
    } else {
      that.getList()
    }

  },
  getList(init = false) {
    //init 用于初始化分页
    if (init.detail != undefined) init = init.detail;
    let params = this.data.params;
    if (init) params.content.pageNumber = 1
    if (params.content.pageNumber > params.content.pageTotal) return;
    let subvalues = this.data.subvalues;
    if (subvalues.length) params.pageSize = 9999
    _Http.basic(params).then(res => {
      console.log("选择账户列表", res)
      this.selectComponent('#ListBox').RefreshToComplete();
      if (res.msg != '成功') return wx.showToast({
        title: res.msg,
        icon: "none"
      })
      if (subvalues.length) res.data = res.data.filter(v => subvalues.includes(v.sa_accountclassid + ""))
      res.data = res.data.map(v => {
        v.balance = CNY(v.balance)
        v.creditquota = CNY(v.creditquota)
        return v
      })
      let list = res.data.filter(v => v.isorder)
      this.setData({
        'params.content.pageNumber': res.pageNumber + 1,
        'params.content.pageTotal': res.pageTotal,
        'params.content.total': res.total,
        list: res.pageNumber == 1 ? list : this.data.list.concat(list),
        loading: false
      })
    })
  },
  /* 选中 */
  changeResult(e) {
    let {
      id
    } = e.currentTarget.dataset, result = this.data.result;
    if (this.data.radio) {
      result = [id];
    } else {
      result.some(v => v == id) ? result = result.filter(v => v != id) : result.push(id)
    }
    this.setData({
      result
    });
    if (this.data.radio) this.submit();
  },
  /* 提交 */
  submit() {
    let result = this.data.result,
      obj = this.data.radio ? {
        id: result,
        item: this.data.list.find(value => value[this.data.idname] == result),
        value: [this.data.list.find(value => value[this.data.idname] == result)[this.data.showName], result]
      } : {
        result,
        list: result.map(v => this.data.list.find(value => value[this.data.idname] == v)),
        value: [result.map(v => {
          let data = this.data.list.find(value => value[this.data.idname] == v);
          return data ? data[this.data.showName] : ""
        }), result]
      }
    console.log(obj);
    getApp().globalData.handleSelect && getApp().globalData.handleSelect(obj)
  },
  /* 开始搜索 */
  startSearch({
    detail
  }) {
    let condition = this.data.content ? this.data.content.where.condition : this.data.params.content.where.condition;
    if (detail == condition) return;
    this.setData({
      'content.where.condition': detail,
      'params.content.where.condition': detail
    });
    this.getList(true);
  },
  /* 取消搜索 */
  onClear() {
    this.setData({
      'content.where.condition': "",
      'params.content.where.condition': ""
    });
    this.getList(true);
  },
  onReady() {
    this.selectComponent("#ListBox").setHeight(".total", this);
  },
  onUnload() {
    //回收数据
    getApp().globalData.handleSelect = null;
  }
})